Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.Designer.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.Designer.cs	(revision 10767)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.Designer.cs	(revision 10768)
@@ -48,10 +48,17 @@
       this.btnApplySort = new System.Windows.Forms.Button();
       this.contextMenuCell = new System.Windows.Forms.ContextMenuStrip(this.components);
-      this.replaceValueToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.averageToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.medianToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.randomToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.mostCommonToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.interpolationToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.replaceValueOverColumnToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.averageToolStripMenuItem_Column = new System.Windows.Forms.ToolStripMenuItem();
+      this.medianToolStripMenuItem_Column = new System.Windows.Forms.ToolStripMenuItem();
+      this.randomToolStripMenuItem_Column = new System.Windows.Forms.ToolStripMenuItem();
+      this.mostCommonToolStripMenuItem_Column = new System.Windows.Forms.ToolStripMenuItem();
+      this.interpolationToolStripMenuItem_Column = new System.Windows.Forms.ToolStripMenuItem();
+      this.replaceValueOverSelectionToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.averageToolStripMenuItem_Selection = new System.Windows.Forms.ToolStripMenuItem();
+      this.medianToolStripMenuItem_Selection = new System.Windows.Forms.ToolStripMenuItem();
+      this.randomToolStripMenuItem_Selection = new System.Windows.Forms.ToolStripMenuItem();
+      this.mostCommonToolStripMenuItem_Selection = new System.Windows.Forms.ToolStripMenuItem();
+      this.interpolationToolStripMenuItem_Selection = new System.Windows.Forms.ToolStripMenuItem();
+      this.smoothingToolStripMenuItem_Selection = new System.Windows.Forms.ToolStripMenuItem();
       this.btnSearch = new System.Windows.Forms.Button();
       this.btnReplace = new System.Windows.Forms.Button();
@@ -95,54 +102,110 @@
       // 
       this.contextMenuCell.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
-            this.replaceValueToolStripMenuItem});
+            this.replaceValueOverColumnToolStripMenuItem,
+            this.replaceValueOverSelectionToolStripMenuItem});
       this.contextMenuCell.Name = "contextMenuCell";
-      this.contextMenuCell.Size = new System.Drawing.Size(148, 26);
-      // 
-      // replaceValueToolStripMenuItem
-      // 
-      this.replaceValueToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
-            this.averageToolStripMenuItem,
-            this.medianToolStripMenuItem,
-            this.randomToolStripMenuItem,
-            this.mostCommonToolStripMenuItem,
-            this.interpolationToolStripMenuItem});
-      this.replaceValueToolStripMenuItem.Name = "replaceValueToolStripMenuItem";
-      this.replaceValueToolStripMenuItem.Size = new System.Drawing.Size(147, 22);
-      this.replaceValueToolStripMenuItem.Text = "Replace Value";
-      // 
-      // averageToolStripMenuItem
-      // 
-      this.averageToolStripMenuItem.Name = "averageToolStripMenuItem";
-      this.averageToolStripMenuItem.Size = new System.Drawing.Size(155, 22);
-      this.averageToolStripMenuItem.Text = "Average";
-      this.averageToolStripMenuItem.Click += new System.EventHandler(this.ReplaceWithAverage_Click);
-      // 
-      // medianToolStripMenuItem
-      // 
-      this.medianToolStripMenuItem.Name = "medianToolStripMenuItem";
-      this.medianToolStripMenuItem.Size = new System.Drawing.Size(155, 22);
-      this.medianToolStripMenuItem.Text = "Median";
-      this.medianToolStripMenuItem.Click += new System.EventHandler(this.ReplaceWithMedian_Click);
-      // 
-      // randomToolStripMenuItem
-      // 
-      this.randomToolStripMenuItem.Name = "randomToolStripMenuItem";
-      this.randomToolStripMenuItem.Size = new System.Drawing.Size(155, 22);
-      this.randomToolStripMenuItem.Text = "Random";
-      this.randomToolStripMenuItem.Click += new System.EventHandler(this.ReplaceWithRandom_Click);
-      // 
-      // mostCommonToolStripMenuItem
-      // 
-      this.mostCommonToolStripMenuItem.Name = "mostCommonToolStripMenuItem";
-      this.mostCommonToolStripMenuItem.Size = new System.Drawing.Size(155, 22);
-      this.mostCommonToolStripMenuItem.Text = "Most Common";
-      this.mostCommonToolStripMenuItem.Click += new System.EventHandler(this.ReplaceWithMostCommon_Click);
-      // 
-      // interpolationToolStripMenuItem
-      // 
-      this.interpolationToolStripMenuItem.Name = "interpolationToolStripMenuItem";
-      this.interpolationToolStripMenuItem.Size = new System.Drawing.Size(155, 22);
-      this.interpolationToolStripMenuItem.Text = "Interpolation";
-      this.interpolationToolStripMenuItem.Click += new System.EventHandler(this.ReplaceWithInterpolation_Click);
+      this.contextMenuCell.Size = new System.Drawing.Size(225, 70);
+      // 
+      // replaceValueOverColumnToolStripMenuItem
+      // 
+      this.replaceValueOverColumnToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.averageToolStripMenuItem_Column,
+            this.medianToolStripMenuItem_Column,
+            this.randomToolStripMenuItem_Column,
+            this.mostCommonToolStripMenuItem_Column,
+            this.interpolationToolStripMenuItem_Column});
+      this.replaceValueOverColumnToolStripMenuItem.Name = "replaceValueOverColumnToolStripMenuItem";
+      this.replaceValueOverColumnToolStripMenuItem.Size = new System.Drawing.Size(224, 22);
+      this.replaceValueOverColumnToolStripMenuItem.Text = "Replace Value over Column";
+      // 
+      // averageToolStripMenuItem_Column
+      // 
+      this.averageToolStripMenuItem_Column.Name = "averageToolStripMenuItem_Column";
+      this.averageToolStripMenuItem_Column.Size = new System.Drawing.Size(155, 22);
+      this.averageToolStripMenuItem_Column.Text = "Average";
+      this.averageToolStripMenuItem_Column.Click += new System.EventHandler(this.ReplaceWithAverage_Column_Click);
+      // 
+      // medianToolStripMenuItem_Column
+      // 
+      this.medianToolStripMenuItem_Column.Name = "medianToolStripMenuItem_Column";
+      this.medianToolStripMenuItem_Column.Size = new System.Drawing.Size(155, 22);
+      this.medianToolStripMenuItem_Column.Text = "Median";
+      this.medianToolStripMenuItem_Column.Click += new System.EventHandler(this.ReplaceWithMedian_Column_Click);
+      // 
+      // randomToolStripMenuItem_Column
+      // 
+      this.randomToolStripMenuItem_Column.Name = "randomToolStripMenuItem_Column";
+      this.randomToolStripMenuItem_Column.Size = new System.Drawing.Size(155, 22);
+      this.randomToolStripMenuItem_Column.Text = "Random";
+      this.randomToolStripMenuItem_Column.Click += new System.EventHandler(this.ReplaceWithRandom_Column_Click);
+      // 
+      // mostCommonToolStripMenuItem_Column
+      // 
+      this.mostCommonToolStripMenuItem_Column.Name = "mostCommonToolStripMenuItem_Column";
+      this.mostCommonToolStripMenuItem_Column.Size = new System.Drawing.Size(155, 22);
+      this.mostCommonToolStripMenuItem_Column.Text = "Most Common";
+      this.mostCommonToolStripMenuItem_Column.Click += new System.EventHandler(this.ReplaceWithMostCommon_Column_Click);
+      // 
+      // interpolationToolStripMenuItem_Column
+      // 
+      this.interpolationToolStripMenuItem_Column.Name = "interpolationToolStripMenuItem_Column";
+      this.interpolationToolStripMenuItem_Column.Size = new System.Drawing.Size(155, 22);
+      this.interpolationToolStripMenuItem_Column.Text = "Interpolation";
+      this.interpolationToolStripMenuItem_Column.Click += new System.EventHandler(this.ReplaceWithInterpolation_Column_Click);
+      // 
+      // replaceValueOverSelectionToolStripMenuItem
+      // 
+      this.replaceValueOverSelectionToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.averageToolStripMenuItem_Selection,
+            this.medianToolStripMenuItem_Selection,
+            this.randomToolStripMenuItem_Selection,
+            this.mostCommonToolStripMenuItem_Selection,
+            this.interpolationToolStripMenuItem_Selection,
+            this.smoothingToolStripMenuItem_Selection});
+      this.replaceValueOverSelectionToolStripMenuItem.Name = "replaceValueOverSelectionToolStripMenuItem";
+      this.replaceValueOverSelectionToolStripMenuItem.Size = new System.Drawing.Size(224, 22);
+      this.replaceValueOverSelectionToolStripMenuItem.Text = "Replace Value over Selection";
+      // 
+      // averageToolStripMenuItem_Selection
+      // 
+      this.averageToolStripMenuItem_Selection.Name = "averageToolStripMenuItem_Selection";
+      this.averageToolStripMenuItem_Selection.Size = new System.Drawing.Size(155, 22);
+      this.averageToolStripMenuItem_Selection.Text = "Average";
+      this.averageToolStripMenuItem_Selection.Click += new System.EventHandler(this.ReplaceWithAverage_Selection_Click);
+      // 
+      // medianToolStripMenuItem_Selection
+      // 
+      this.medianToolStripMenuItem_Selection.Name = "medianToolStripMenuItem_Selection";
+      this.medianToolStripMenuItem_Selection.Size = new System.Drawing.Size(155, 22);
+      this.medianToolStripMenuItem_Selection.Text = "Median";
+      this.medianToolStripMenuItem_Selection.Click += new System.EventHandler(this.ReplaceWithMedian_Selection_Click);
+      // 
+      // randomToolStripMenuItem_Selection
+      // 
+      this.randomToolStripMenuItem_Selection.Name = "randomToolStripMenuItem_Selection";
+      this.randomToolStripMenuItem_Selection.Size = new System.Drawing.Size(155, 22);
+      this.randomToolStripMenuItem_Selection.Text = "Random";
+      this.randomToolStripMenuItem_Selection.Click += new System.EventHandler(this.ReplaceWithRandom_Selection_Click);
+      // 
+      // mostCommonToolStripMenuItem_Selection
+      // 
+      this.mostCommonToolStripMenuItem_Selection.Name = "mostCommonToolStripMenuItem_Selection";
+      this.mostCommonToolStripMenuItem_Selection.Size = new System.Drawing.Size(155, 22);
+      this.mostCommonToolStripMenuItem_Selection.Text = "Most Common";
+      this.mostCommonToolStripMenuItem_Selection.Click += new System.EventHandler(this.ReplaceWithMostCommon_Selection_Click);
+      // 
+      // interpolationToolStripMenuItem_Selection
+      // 
+      this.interpolationToolStripMenuItem_Selection.Name = "interpolationToolStripMenuItem_Selection";
+      this.interpolationToolStripMenuItem_Selection.Size = new System.Drawing.Size(155, 22);
+      this.interpolationToolStripMenuItem_Selection.Text = "Interpolation";
+      this.interpolationToolStripMenuItem_Selection.Click += new System.EventHandler(this.ReplaceWithInterpolation_Selection_Click);
+      // 
+      // smoothingToolStripMenuItem_Selection
+      // 
+      this.smoothingToolStripMenuItem_Selection.Name = "smoothingToolStripMenuItem_Selection";
+      this.smoothingToolStripMenuItem_Selection.Size = new System.Drawing.Size(155, 22);
+      this.smoothingToolStripMenuItem_Selection.Text = "Smoothing";
+      this.smoothingToolStripMenuItem_Selection.Click += new System.EventHandler(this.ReplaceWithSmoothing_Selection_Click);
       // 
       // btnSearch
@@ -196,10 +259,17 @@
     private System.Windows.Forms.Button btnApplySort;
     private System.Windows.Forms.ContextMenuStrip contextMenuCell;
-    private System.Windows.Forms.ToolStripMenuItem replaceValueToolStripMenuItem;
-    private System.Windows.Forms.ToolStripMenuItem averageToolStripMenuItem;
-    private System.Windows.Forms.ToolStripMenuItem medianToolStripMenuItem;
-    private System.Windows.Forms.ToolStripMenuItem randomToolStripMenuItem;
-    private System.Windows.Forms.ToolStripMenuItem mostCommonToolStripMenuItem;
-    private System.Windows.Forms.ToolStripMenuItem interpolationToolStripMenuItem;
+    private System.Windows.Forms.ToolStripMenuItem replaceValueOverColumnToolStripMenuItem;
+    private System.Windows.Forms.ToolStripMenuItem averageToolStripMenuItem_Column;
+    private System.Windows.Forms.ToolStripMenuItem medianToolStripMenuItem_Column;
+    private System.Windows.Forms.ToolStripMenuItem randomToolStripMenuItem_Column;
+    private System.Windows.Forms.ToolStripMenuItem mostCommonToolStripMenuItem_Column;
+    private System.Windows.Forms.ToolStripMenuItem interpolationToolStripMenuItem_Column;
+    private System.Windows.Forms.ToolStripMenuItem replaceValueOverSelectionToolStripMenuItem;
+    private System.Windows.Forms.ToolStripMenuItem averageToolStripMenuItem_Selection;
+    private System.Windows.Forms.ToolStripMenuItem medianToolStripMenuItem_Selection;
+    private System.Windows.Forms.ToolStripMenuItem randomToolStripMenuItem_Selection;
+    private System.Windows.Forms.ToolStripMenuItem mostCommonToolStripMenuItem_Selection;
+    private System.Windows.Forms.ToolStripMenuItem interpolationToolStripMenuItem_Selection;
+    private System.Windows.Forms.ToolStripMenuItem smoothingToolStripMenuItem_Selection;
     private System.Windows.Forms.Button btnSearch;
     private System.Windows.Forms.Button btnReplace;