Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.cs	(revision 10768)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.cs	(revision 10769)
@@ -280,5 +280,5 @@
       if (e.Button == System.Windows.Forms.MouseButtons.Right) {
         if (e.ColumnIndex == -1 || e.RowIndex == -1) {
-          replaceValueToolStripMenuItem.Visible = false;
+          replaceValueOverColumnToolStripMenuItem.Visible = false;
           contextMenuCell.Show(MousePosition);
         } else {
@@ -287,12 +287,12 @@
             dataGridView[e.ColumnIndex, e.RowIndex].Selected = true;
           }
-          interpolationToolStripMenuItem.Enabled = !(e.RowIndex == 0 || e.RowIndex == Content.Rows);
+          interpolationToolStripMenuItem_Column.Enabled = !(e.RowIndex == 0 || e.RowIndex == Content.Rows);
           var columnIndices = new HashSet<int>();
           for (int i = 0; i < dataGridView.SelectedCells.Count; i++) {
             columnIndices.Add(dataGridView.SelectedCells[i].ColumnIndex);
           }
-          averageToolStripMenuItem.Enabled = medianToolStripMenuItem.Enabled = randomToolStripMenuItem.Enabled = !Content.DataGridLogic.AreAllStringColumns(columnIndices);
-          interpolationToolStripMenuItem.Enabled = interpolationToolStripMenuItem.Enabled && !Content.DataGridLogic.AreAllStringColumns(columnIndices);
-          replaceValueToolStripMenuItem.Visible = true;
+          averageToolStripMenuItem_Column.Enabled = medianToolStripMenuItem_Column.Enabled = randomToolStripMenuItem_Column.Enabled = !Content.DataGridLogic.AreAllStringColumns(columnIndices);
+          interpolationToolStripMenuItem_Column.Enabled = interpolationToolStripMenuItem_Column.Enabled && !Content.DataGridLogic.AreAllStringColumns(columnIndices);
+          replaceValueOverColumnToolStripMenuItem.Visible = true;
           contextMenuCell.Show(MousePosition);
         }
@@ -380,24 +380,41 @@
     }
 
-    private void ReplaceWithAverage_Click(object sender, EventArgs e) {
+    private void ReplaceWithAverage_Column_Click(object sender, EventArgs e) {
       Content.PreprocessingDataManipulation.ReplaceIndicesByAverageValue(GetSelectedCells());
     }
 
-    private void ReplaceWithMedian_Click(object sender, EventArgs e) {
+    private void ReplaceWithMedian_Column_Click(object sender, EventArgs e) {
       Content.PreprocessingDataManipulation.ReplaceIndicesByMedianValue(GetSelectedCells());
     }
 
-    private void ReplaceWithRandom_Click(object sender, EventArgs e) {
+    private void ReplaceWithRandom_Column_Click(object sender, EventArgs e) {
       Content.PreprocessingDataManipulation.ReplaceIndicesByRandomValue(GetSelectedCells());
     }
 
-    private void ReplaceWithMostCommon_Click(object sender, EventArgs e) {
+    private void ReplaceWithMostCommon_Column_Click(object sender, EventArgs e) {
       Content.PreprocessingDataManipulation.ReplaceIndicesByMostCommonValue(GetSelectedCells());
     }
 
-    private void ReplaceWithInterpolation_Click(object sender, EventArgs e) {
+    private void ReplaceWithInterpolation_Column_Click(object sender, EventArgs e) {
       Content.PreprocessingDataManipulation.ReplaceIndicesByLinearInterpolationOfNeighbours(GetSelectedCells());
     }
 
+    private void ReplaceWithAverage_Selection_Click(object sender, EventArgs e) {
+    }
+
+    private void ReplaceWithMedian_Selection_Click(object sender, EventArgs e) {
+    }
+
+    private void ReplaceWithRandom_Selection_Click(object sender, EventArgs e) {
+    }
+
+    private void ReplaceWithMostCommon_Selection_Click(object sender, EventArgs e) {
+    }
+
+    private void ReplaceWithInterpolation_Selection_Click(object sender, EventArgs e) {
+    }
+
+    private void ReplaceWithSmoothing_Selection_Click(object sender, EventArgs e) {
+    }
 
     private void btnSearch_Click(object sender, EventArgs e) {