Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataPreprocessingView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataPreprocessingView.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataPreprocessingView.cs	(revision 10772)
@@ -49,16 +49,13 @@
         var statisticsLogic = new StatisticsLogic(data, searchLogic);
         var manipulationLogic = new ManipulationLogic(data, searchLogic, statisticsLogic, dataGridLogic);
-        var transformationLogic = new TransformationLogic(data, searchLogic, statisticsLogic);
         var lineChartLogic = new ChartLogic(data);
         var histogramLogic = new ChartLogic(data);
         var filterLogic = new FilterLogic(data);
 
-        
-
-        var viewShortcuts = new ItemCollection<IViewShortcut>() {
+        var viewShortcuts = new ItemCollection<IViewShortcut> {
           new DataGridContent(dataGridLogic, manipulationLogic, filterLogic),
           new StatisticsContent(statisticsLogic),
           new FilterContent(filterLogic),
-          new TransformationContent(transformationLogic),
+          new TransformationContent(data),
           new ManipulationContent(manipulationLogic),
           new LineChartContent(lineChartLogic),
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HeuristicLab.DataPreprocessing.Views-3.3.csproj
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HeuristicLab.DataPreprocessing.Views-3.3.csproj	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HeuristicLab.DataPreprocessing.Views-3.3.csproj	(revision 10772)
@@ -226,4 +226,8 @@
       <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Transformations\3.3\HeuristicLab.Problems.DataAnalysis.Transformations-3.3.csproj">
+      <Project>{2e257a94-d1af-435c-99b4-5ac00eadfd6a}</Project>
+      <Name>HeuristicLab.Problems.DataAnalysis.Transformations-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Views\3.4\HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj">
       <Project>{3E9E8944-44FF-40BB-A622-3A4A7DD0F198}</Project>
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/Plugin.cs.frame
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/Plugin.cs.frame	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/Plugin.cs.frame	(revision 10772)
@@ -34,4 +34,5 @@
   [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")] 
   [PluginDependency("HeuristicLab.Problems.DataAnalysis.Views","3.4")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis.Transformations", "3.3")]
   public class HeuristicLabDataPreprocessingPlugin : PluginBase {
   }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.Designer.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.Designer.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.Designer.cs	(revision 10772)
@@ -19,4 +19,6 @@
  */
 #endregion
+
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.DataPreprocessing.Views {
@@ -45,15 +47,15 @@
     /// </summary>
     private void InitializeComponent() {
-      this.label1 = new System.Windows.Forms.Label();
-      this.SuspendLayout();
+      components = new System.ComponentModel.Container();
+      this.transformationCollectionView = new HeuristicLab.Core.Views.CheckedItemCollectionView<ITransformation>();
+      // transformationCollectionView
       // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(26, 68);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(103, 13);
-      this.label1.TabIndex = 0;
-      this.label1.Text = "Not yet implemented";
+      this.transformationCollectionView.Caption = "Transformations";
+      this.transformationCollectionView.Content = null;
+      this.transformationCollectionView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.transformationCollectionView.Location = new System.Drawing.Point(0, 0);
+      this.transformationCollectionView.Name = "transformationCollectionView";
+      this.transformationCollectionView.Size = new System.Drawing.Size(627, 528);
+      this.transformationCollectionView.TabIndex = 0;
       // 
       // TransformationView
@@ -61,14 +63,13 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.label1);
+      this.Controls.Add(this.transformationCollectionView);
       this.Name = "TransformationView";
+      this.Size = new System.Drawing.Size(627, 528);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
 
     #endregion
-
-    private System.Windows.Forms.Label label1;
+    private Core.Views.CheckedItemCollectionView<ITransformation> transformationCollectionView;
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.cs	(revision 10772)
@@ -22,4 +22,5 @@
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.DataPreprocessing.Views {
@@ -36,4 +37,13 @@
       set { base.Content = value; }
     }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        transformationCollectionView.Content = null;
+      } else {
+        transformationCollectionView.Content = Content.CheckedTransformationCollection;
+      }
+    }
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingData.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingData.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingData.cs	(revision 10772)
@@ -28,4 +28,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.DataPreprocessing {
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/TransformationContent.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/TransformationContent.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/TransformationContent.cs	(revision 10772)
@@ -23,4 +23,6 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.DataPreprocessing {
@@ -28,18 +30,17 @@
   public class TransformationContent : Item, IViewShortcut {
 
-    private readonly ITransformationLogic transformationLogic;
-    public TransformationContent(ITransformationLogic theTransformationLogic) {
-      transformationLogic = theTransformationLogic;
+    public IPreprocessingData Data { get; private set; }
+
+    public ICheckedItemCollection<ITransformation> CheckedTransformationCollection { get; private set; }
+
+    public TransformationContent(IPreprocessingData data) {
+      Data = data;
+      CheckedTransformationCollection = new CheckedItemCollection<ITransformation>();
     }
 
-    public ITransformationLogic TransformationLogic {
-      get {
-        return transformationLogic;
-      }
-    }
-
-    public TransformationContent(TransformationContent content, Cloner cloner)
-      : base(content, cloner) {
-
+    public TransformationContent(TransformationContent original, Cloner cloner)
+      : base(original, cloner) {
+      Data = original.Data;
+      CheckedTransformationCollection = new CheckedItemCollection<ITransformation>(original.CheckedTransformationCollection);
     }
 
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IPreprocessingData.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IPreprocessingData.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IPreprocessingData.cs	(revision 10772)
@@ -25,4 +25,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.DataPreprocessing {
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/ProblemDataCreator.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/ProblemDataCreator.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/ProblemDataCreator.cs	(revision 10772)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.DataPreprocessing {
@@ -36,5 +37,4 @@
     private IEnumerable<string> InputVariables { get { return context.Data.VariableNames; } }
     private IEnumerable<ITransformation> Transformations { get { return context.Data.Transformations; } }
-
 
     public ProblemDataCreator(IPreprocessingContext context) {
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Properties/AssemblyInfo.cs.frame	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Properties/AssemblyInfo.cs.frame	(revision 10772)
@@ -32,5 +32,4 @@
 // You can specify all the values or you can default the Build and Revision Numbers 
 // by using the '*' as shown below:
-// [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.9.0")]
 [assembly: AssemblyFileVersion("3.3.9.$WCREV$")]
Index: branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Trading/3.4/ProblemData.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Trading/3.4/ProblemData.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Trading/3.4/ProblemData.cs	(revision 10772)
@@ -28,4 +28,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.Problems.DataAnalysis.Trading {
Index: branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/Interfaces/ITransformation.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/Interfaces/ITransformation.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis.Transformations/3.3/Interfaces/ITransformation.cs	(revision 10772)
@@ -23,5 +23,5 @@
 using HeuristicLab.Core;
 
-namespace HeuristicLab.Problems.DataAnalysis {
+namespace HeuristicLab.Problems.DataAnalysis.Transformations {
   public interface ITransformation : IParameterizedItem {
     string Column { get; }
Index: branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationProblemData.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationProblemData.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationProblemData.cs	(revision 10772)
@@ -28,4 +28,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.Problems.DataAnalysis {
Index: branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Clustering/ClusteringProblemData.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Clustering/ClusteringProblemData.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Clustering/ClusteringProblemData.cs	(revision 10772)
@@ -25,4 +25,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.Problems.DataAnalysis {
Index: branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblemData.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblemData.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblemData.cs	(revision 10772)
@@ -29,4 +29,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.Problems.DataAnalysis {
@@ -118,9 +119,8 @@
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
-      RegisterEventHandlers();
-
       if (!Parameters.ContainsKey(TransformationsParameterName)) {
         Parameters.Add(new FixedValueParameter<ReadOnlyItemCollection<ITransformation>>(TransformationsParameterName, "", new ItemCollection<ITransformation>().AsReadOnly()));
       }
+      RegisterEventHandlers();
     }
 
@@ -160,4 +160,5 @@
       TrainingPartition.ValueChanged += new EventHandler(Parameter_ValueChanged);
       TestPartition.ValueChanged += new EventHandler(Parameter_ValueChanged);
+      TransformationsParameter.ValueChanged += new EventHandler(Parameter_ValueChanged);
     }
 
Index: branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 10772)
@@ -28,4 +28,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.Problems.DataAnalysis {
Index: branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisProblemData.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisProblemData.cs	(revision 10771)
+++ branches/DataPreprocessing/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisProblemData.cs	(revision 10772)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Problems.DataAnalysis.Transformations;
 
 namespace HeuristicLab.Problems.DataAnalysis {